Index: LMDZ4/branches/pre_V3/libf/dyn3d/iniinterp_horiz.F
===================================================================
--- LMDZ4/branches/pre_V3/libf/dyn3d/iniinterp_horiz.F	(revision 701)
+++ LMDZ4/branches/pre_V3/libf/dyn3d/iniinterp_horiz.F	(revision 701)
@@ -0,0 +1,179 @@
+C 
+C $Header$
+C
+      subroutine iniinterp_horiz (imo,jmo,imn,jmn ,kllm,
+     &       rlonuo,rlatvo,rlonun,rlatvn,
+     &       ktotal,iik,jjk,jk,ik,intersec,airen)
+   
+      implicit none
+
+
+
+c ---------------------------------------------------------
+c Prepare l' interpolation des variables d'une grille LMDZ
+c  dans une autre grille LMDZ en conservant la quantite
+c  totale pour les variables intensives (/m2) : ex : Pression au sol
+c
+c   (Pour chaque case autour d'un point scalaire de la nouvelle
+c    grille, on calcule la surface (en m2)en intersection avec chaque
+c    case de l'ancienne grille , pour la future interpolation)
+c
+c on calcule aussi l' aire dans la nouvelle grille 
+c
+c
+c   Auteur:  F.Forget 01/1995
+c   -------
+c
+c ---------------------------------------------------------
+c   Declarations:
+c ==============
+c
+c  ARGUMENTS
+c  """""""""
+c INPUT
+       integer imo, jmo ! dimensions ancienne grille
+       integer imn,jmn  ! dimensions nouvelle grille
+       integer kllm ! taille du tableau des intersections
+       real rlonuo(imo+1)     !  Latitude et
+       real rlatvo(jmo)       !  longitude des
+       real rlonun(imn+1)     !  bord des
+       real rlatvn(jmn)     !  cases "scalaires" (input)
+
+c OUTPUT
+       integer ktotal ! nombre totale d'intersections reperees
+       integer iik(kllm), jjk(kllm),jk(kllm),ik(kllm)
+       real intersec(kllm)  ! surface des intersections (m2)
+       real airen (imn+1,jmn+1) ! aire dans la nouvelle grille
+
+
+       
+ 
+c Autres variables
+c """"""""""""""""
+       integer i,j,ii,jj,k
+       real a(imo+1),b(imo+1),c(jmo+1),d(jmo+1)
+       real an(imn+1),bn(imn+1),cn(jmn+1),dn(jmn+1)
+       real aa, bb,cc,dd
+       real pi
+
+       pi      = 2.*ASIN( 1. )
+
+
+
+c On repere les frontieres des cases :
+c =================================== 
+c
+c Attention, on ruse avec des latitudes = 90 deg au pole.
+
+
+c  ANcienne grile
+c  """"""""""""""
+      a(1) =   - rlonuo(imo+1)
+      b(1) = rlonuo(1)
+      do i=2,imo+1
+         a(i) = rlonuo(i-1)
+         b(i) =  rlonuo(i)
+      end do
+
+      d(1) = pi/2 
+      do j=1,jmo
+         c(j) = rlatvo(j) 
+         d(j+1) = rlatvo(j)
+      end do
+      c(jmo+1) = -pi/2 
+      
+
+c  Nouvelle grille
+c  """""""""""""""
+      an(1) =  - rlonun(imn+1)
+      bn(1) = rlonun(1)
+      do i=2,imn+1
+         an(i) = rlonun(i-1)
+         bn(i) =  rlonun(i)
+      end do
+
+      dn(1) = pi/2 
+      do j=1,jmn
+         cn(j) = rlatvn(j)
+         dn(j+1) = rlatvn(j)
+      end do
+      cn(jmn+1) = -pi/2 
+
+c Calcul de la surface des cases scalaires de la nouvelle grille
+c ==============================================================
+      do ii=1,imn + 1
+        do jj = 1,jmn+1
+               airen(ii,jj) = (bn(ii)-an(ii))*(sin(dn(jj))-sin(cn(jj)))
+        end do
+      end do
+
+c Calcul de la surface des intersections
+c ======================================
+
+c     boucle sur la nouvelle grille
+c     """"""""""""""""""""""""""""
+      ktotal = 0
+      do jj = 1,jmn+1
+       do j=1, jmo+1
+          if((cn(jj).lt.d(j)).and.(dn(jj).gt.c(j)))then
+              do ii=1,imn + 1
+                do i=1, imo +1
+                    if (  ((an(ii).lt.b(i)).and.(bn(ii).gt.a(i)))
+     &        .or. ((an(ii).lt.b(i)-2*pi).and.(bn(ii).gt.a(i)-2*pi)
+     &             .and.(b(i)-2*pi.lt.-pi) )
+     &        .or. ((an(ii).lt.b(i)+2*pi).and.(bn(ii).gt.a(i)+2*pi)
+     &             .and.(a(i)+2*pi.gt.pi) )
+     &                     )then
+                      ktotal = ktotal +1
+                      iik(ktotal) =ii
+                      jjk(ktotal) =jj
+                      ik(ktotal) =i
+                      jk(ktotal) =j
+
+                      dd = min(d(j), dn(jj))
+                      cc = cn(jj)
+                      if (cc.lt. c(j))cc=c(j)
+                      if((an(ii).lt.b(i)-2*pi).and.
+     &                  (bn(ii).gt.a(i)-2*pi)) then 
+                          bb = min(b(i)-2*pi,bn(ii))
+                          aa = an(ii)
+                          if (aa.lt.a(i)-2*pi) aa=a(i)-2*pi
+                      else if((an(ii).lt.b(i)+2*pi).and.
+     &                       (bn(ii).gt.a(i)+2*pi)) then
+                          bb = min(b(i)+2*pi,bn(ii))
+                          aa = an(ii)
+                          if (aa.lt.a(i)+2*pi) aa=a(i)+2*pi
+                      else 
+                          bb = min(b(i),bn(ii))
+                          aa = an(ii)
+                          if (aa.lt.a(i)) aa=a(i)
+                      end if
+                      intersec(ktotal)=(bb-aa)*(sin(dd)-sin(cc))
+                     end if
+                end do
+               end do
+             end if
+         end do
+       end do       
+
+
+
+c     TEST  INFO
+c     DO k=1,ktotal 
+c      ii = iik(k) 
+c      jj = jjk(k)
+c      i = ik(k)
+c      j = jk(k)
+c      if ((ii.eq.10).and.(jj.eq.10).and.(i.eq.10).and.(j.eq.10))then
+c      if (jj.eq.2.and.(ii.eq.1))then
+c          write(*,*) '**************** jj=',jj,'ii=',ii
+c          write(*,*) 'i,j =',i,j
+c          write(*,*) 'an,bn,cn,dn', an(ii), bn(ii), cn(jj),dn(jj)
+c          write(*,*) 'a,b,c,d', a(i), b(i), c(j),d(j)
+c          write(*,*) 'intersec(k)',intersec(k)
+c          write(*,*) 'airen(ii,jj)=',airen(ii,jj)
+c      end if
+c     END DO 
+
+      return
+      end
Index: LMDZ4/branches/pre_V3/libf/dyn3d/interp_horiz.F
===================================================================
--- LMDZ4/branches/pre_V3/libf/dyn3d/interp_horiz.F	(revision 701)
+++ LMDZ4/branches/pre_V3/libf/dyn3d/interp_horiz.F	(revision 701)
@@ -0,0 +1,154 @@
+c
+c $Header$
+c
+      subroutine interp_horiz (varo,varn,imo,jmo,imn,jmn,lm,
+     &  rlonuo,rlatvo,rlonun,rlatvn)  
+
+c===========================================================
+c  Interpolation Horizontales des variables d'une grille LMDZ
+c (des points SCALAIRES au point SCALAIRES)
+c  dans une autre grille LMDZ en conservant la quantite
+c  totale pour les variables intensives (/m2) : ex : Pression au sol
+c
+c Francois Forget (01/1995)
+c===========================================================
+
+      IMPLICIT NONE 
+
+c   Declarations:
+c ==============
+c
+c  ARGUMENTS
+c  """""""""
+        
+       integer imo, jmo ! dimensions ancienne grille (input)
+       integer imn,jmn  ! dimensions nouvelle grille (input)
+
+       real rlonuo(imo+1)     !  Latitude et
+       real rlatvo(jmo)       !  longitude des
+       real rlonun(imn+1)     !  bord des 
+       real rlatvn(jmn)     !  cases "scalaires" (input)
+
+       integer lm ! dimension verticale (input)
+       real varo (imo+1, jmo+1,lm) ! var dans l'ancienne grille (input)
+       real varn (imn+1,jmn+1,lm) ! var dans la nouvelle grille (output)
+
+c Autres variables
+c """"""""""""""""
+       real airetest(imn+1,jmn+1)
+       integer ii,jj,l
+
+       real airen (imn+1,jmn+1) ! aire dans la nouvelle grille
+c    Info sur les ktotal intersection entre les cases new/old grille
+       integer kllm, k, ktotal
+       parameter (kllm = 400*200*10)
+       integer iik(kllm), jjk(kllm),jk(kllm),ik(kllm)
+       real intersec(kllm)
+       real R
+       real totn, tots
+
+       logical firstcall, firsttest, aire_ok
+       save firsttest
+       data firsttest /.true./
+       data aire_ok /.true./
+
+       
+
+
+
+c initialisation
+c --------------
+c Si c'est le premier appel, on prepare l'interpolation
+c en calculant pour chaque case autour d'un point scalaire de la
+c nouvelle grille, la surface  de intersection avec chaque
+c    case de l'ancienne grille.
+
+
+        call iniinterp_horiz (imo,jmo,imn,jmn ,kllm,
+     &       rlonuo,rlatvo,rlonun,rlatvn,
+     &          ktotal,iik,jjk,jk,ik,intersec,airen)
+
+      do l=1,lm
+       do jj =1 , jmn+1
+        do ii=1, imn+1
+          varn(ii,jj,l) =0.
+        end do
+       end do
+      end do 
+       
+c Interpolation horizontale
+c -------------------------
+c boucle sur toute les ktotal intersections entre les cases
+c de l'ancienne et la  nouvelle grille
+c
+      PRINT *, 'ktotal 1 = ', ktotal
+     
+      do k=1,ktotal
+        do l=1,lm
+         varn(iik(k),jjk(k),l) = varn(iik(k),jjk(k),l) 
+     &        + varo(ik(k), jk(k),l)*intersec(k)/airen(iik(k),jjk(k))
+        end do
+      end do
+
+c Une seule valeur au pole pour les variables ! :
+c -----------------------------------------------
+       do l=1, lm
+         totn =0.
+         tots =0.
+           do ii =1, imn+1
+             totn = totn + varn(ii,1,l)
+             tots = tots + varn (ii,jmn+1,l)
+           end do 
+           do ii =1, imn+1
+             varn(ii,1,l) = totn/float(imn+1)
+             varn(ii,jmn+1,l) = tots/float(imn+1)
+           end do 
+       end do
+           
+
+c---------------------------------------------------------------
+c  TEST  TEST  TEST  TEST  TEST  TEST  TEST  TEST  TEST  TEST 
+!!       if (.not.(firsttest)) goto 99
+!!       firsttest = .false.
+!! !     write (*,*) 'INTERP. HORIZ. : TEST SUR LES AIRES:'
+!!       do jj =1 , jmn+1
+!!         do ii=1, imn+1
+!!           airetest(ii,jj) =0.
+!!         end do
+!!       end do 
+!!       PRINT *, 'ktotal = ', ktotal
+!!       PRINT *, 'jmn+1 =', jmn+1, 'imn+1', imn+1
+!! 
+!!       do k=1,ktotal
+!!          airetest(iik(k),jjk(k))= airetest(iik(k),jjk(k)) +intersec(k) 
+!!       end DO
+!! 
+!! 
+!!       PRINT *, 'fin boucle'
+!!       do jj =1 , jmn+1
+!!        do ii=1, imn+1
+!!          r = airen(ii,jj)/airetest(ii,jj)
+!!          if ((r.gt.1.001).or.(r.lt.0.999)) then
+!! !             write (*,*) '********** PROBLEME D'' AIRES !!!',
+!! !     &                   ' DANS L''INTERPOLATION HORIZONTALE'
+!! !             write(*,*)'ii,jj,airen,airetest',
+!! !     &          ii,jj,airen(ii,jj),airetest(ii,jj)
+!!              aire_ok = .false.
+!!          end if
+!!        end do
+!!       end do
+!! !      if (aire_ok) write(*,*) 'INTERP. HORIZ. : AIRES OK'
+!!  99   continue
+
+c FIN TEST  FIN TEST  FIN TEST  FIN TEST  FIN TEST  FIN TEST  FIN TEST
+c---------------------------------------------------------------
+
+
+
+
+
+
+
+
+        return
+        end
Index: LMDZ4/branches/pre_V3/libf/dyn3d/leapfrog.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/leapfrog.F	(revision 525)
+++ LMDZ4/branches/pre_V3/libf/dyn3d/leapfrog.F	(revision 701)
@@ -4,9 +4,13 @@
 c
 c
-      SUBROUTINE leapfrog(ucov,vcov,teta,ps,masse,phis,nq,q,clesphy0)
+      SUBROUTINE leapfrog(ucov,vcov,teta,ps,masse,phis,nq,q,clesphy0,
+     &                    time_0)
 
 #ifdef INCA
       USE transport_controls, ONLY : hadv_flg, mmt_adj
 #endif
+
+cIM : pour sortir les param. du modele dans un fis. netcdf 110106
+      USE IOIPSL 
 
       IMPLICIT NONE
@@ -62,4 +66,6 @@
 #include "academic.h"
 
+#include "clesphys.h"
+
       integer nq
 
@@ -117,5 +123,6 @@
       REAL time_0 , finvmaold(ip1jmp1,llm)
 
-      LOGICAL lafin
+cym      LOGICAL  lafin
+      LOGICAL :: lafin=.false.
       INTEGER ij,iq,l
       INTEGER ik
@@ -125,4 +132,18 @@
       REAL rdayvrai,rdaym_ini
       LOGICAL first,callinigrads
+cIM : pour sortir les param. du modele dans un fis. netcdf 110106
+      save first
+      data first/.true./
+      real dt_cum, zjulian
+      character*10 infile
+      integer zan, tau0, thoriid
+      integer nid_ctesGCM
+      save nid_ctesGCM
+      real degres
+      real rlong(iip1), rlatg(jjp1)
+      real zx_tmp_2d(iip1,jjp1)
+      integer ndex2d(iip1*jjp1)
+      logical ok_sync
+      parameter (ok_sync = .true.) 
 
       data callinigrads/.true./
@@ -130,5 +151,5 @@
 
       REAL alpha(ip1jmp1,llm),beta(ip1jmp1,llm)
-#ifdef INCA_CH4
+#ifdef INCA
       REAL :: flxw(ip1jmp1,llm)
 #endif
@@ -144,11 +165,8 @@
       REAL      d_h_vcol, d_qt, d_qw, d_ql, d_ec
       CHARACTER*15 ztit
-      INTEGER   ip_ebil_dyn  ! PRINT level for energy conserv. diag.
-      SAVE      ip_ebil_dyn
-      DATA      ip_ebil_dyn/0/
+!IM   INTEGER   ip_ebil_dyn  ! PRINT level for energy conserv. diag.
+!IM   SAVE      ip_ebil_dyn
+!IM   DATA      ip_ebil_dyn/0/
 c-jld 
-
-      LOGICAL offline  ! Controle du stockage ds "fluxmass"
-      PARAMETER (offline=.false.)
 
       character*80 dynhist_file, dynhistave_file
@@ -199,6 +217,9 @@
 
 #ifdef CPP_IOIPSL
-      if (ok_guide) then
+      if (ok_guide.and.(itaufin-itau-1)*dtvr.gt.21600) then
         call guide(itau,ucov,vcov,teta,q,masse,ps)
+      else
+        IF(prt_level>9)WRITE(*,*)'attention on ne guide pas les ',
+     .    '6 dernieres heures'
       endif
 #endif
@@ -272,5 +293,5 @@
 
 c
-#ifdef INCA_CH4
+#ifdef INCA
              CALL caladvtrac(q,pbaru,pbarv,
      *                      p, masse, dq,  teta,
@@ -289,6 +310,6 @@
 
 #ifdef CPP_IOIPSL
-c           CALL fluxstokenc(pbaru,pbarv,masse,teta,phi,phis,
-c    .   time_step, itau)
+           CALL fluxstokenc(pbaru,pbarv,masse,teta,phi,phis,
+     .   dtvr, itau)
 #endif
 
@@ -352,9 +373,17 @@
       ENDIF 
 c-jld
+cIM : pour sortir les param. du modele dans un fis. netcdf 110106
+      IF (first) THEN
+       first=.false.
+#include "ini_paramLMDZ_dyn.h"
+      ENDIF
+c
+#include "write_paramLMDZ_dyn.h"
+c
 
         CALL calfis( nq, lafin ,rdayvrai,time  ,
      $               ucov,vcov,teta,q,masse,ps,p,pk,phis,phi ,
      $               du,dv,dteta,dq,w,
-#ifdef INCA_CH4
+#ifdef INCA
      $               flxw,
 #endif
@@ -486,11 +515,11 @@
 
             IF( itau. EQ. itaufinp1 ) then  
-c      write(79,*) 'ucov',ucov
-c      write(80,*) 'vcov',vcov
-c      write(81,*) 'teta',teta
-c      write(82,*) 'ps',ps
-c      write(83,*) 'q',q
-c      WRITE(85,*) 'q1 = ',q(:,:,1)
-c      WRITE(86,*) 'q3 = ',q(:,:,3)
+c$$$       write(79,*) 'ucov',ucov
+c$$$       write(80,*) 'vcov',vcov
+c$$$       write(81,*) 'teta',teta
+c$$$       write(82,*) 'ps',ps
+c$$$       write(83,*) 'q',q
+c$$$       WRITE(85,*) 'q1 = ',q(:,:,1)
+c$$$       WRITE(86,*) 'q3 = ',q(:,:,3)
 
               abort_message = 'Simulation finished'
Index: LMDZ4/branches/pre_V3/libf/dyn3d/limit_netcdf.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/limit_netcdf.F	(revision 525)
+++ LMDZ4/branches/pre_V3/libf/dyn3d/limit_netcdf.F	(revision 701)
@@ -452,7 +452,10 @@
 
       ierr = NF_OPEN('amipbc_sic_1x1.nc', NF_NOWRITE, ncid)
-      if (ierr.ne.0) then
-        print *, NF_STRERROR(ierr)
-        STOP
+      if (ierr.ne.0) THEN
+        ierr = NF_OPEN('amipbc_sic_1x1_clim.nc', NF_NOWRITE, ncid)
+        if (ierr.ne.0) THEN
+          print *, NF_STRERROR(ierr)
+          STOP
+        endif
       ENDIF
 
@@ -775,7 +778,10 @@
 c     ierr = NF_OPEN('AMIP_SST.nc', NF_NOWRITE, ncid)
       ierr = NF_OPEN('amipbc_sst_1x1.nc', NF_NOWRITE, ncid)
-      if (ierr.ne.0) then
-        print *, NF_STRERROR(ierr)
-        STOP
+      if (ierr.ne.0) THEN
+        ierr = NF_OPEN('amipbc_sst_1x1_clim.nc', NF_NOWRITE, ncid)
+        if (ierr.ne.0) THEN
+          print *, NF_STRERROR(ierr)
+          STOP
+        endif
       ENDIF
 
Index: LMDZ4/branches/pre_V3/libf/dyn3d/parallel.F90
===================================================================
--- LMDZ4/branches/pre_V3/libf/dyn3d/parallel.F90	(revision 701)
+++ LMDZ4/branches/pre_V3/libf/dyn3d/parallel.F90	(revision 701)
@@ -0,0 +1,463 @@
+  module parallel
+  
+    integer, save :: mpi_size
+    integer, save :: mpi_rank
+    integer, save :: jj_begin
+    integer, save :: jj_end
+    integer, save :: jj_nb
+    integer, save :: ij_begin
+    integer, save :: ij_end
+    logical, save :: pole_nord
+    logical, save :: pole_sud
+    
+    integer, allocatable, save, dimension(:) :: jj_begin_para
+    integer, allocatable, save, dimension(:) :: jj_end_para
+    integer, allocatable, save, dimension(:) :: jj_nb_para
+    
+ contains
+
+    subroutine init_parallel
+
+#ifdef CPP_PARALLEL
+
+    USE vampir
+    implicit none
+    
+      integer :: ierr
+      integer :: i,j
+      integer :: type_size
+      integer, dimension(3) :: blocklen,type
+      
+      
+      include 'mpif.h'
+#include "dimensions90.h"
+#include "paramet90.h"
+      
+      call MPI_INIT(ierr)
+      call InitVampir
+      call MPI_COMM_SIZE(MPI_COMM_WORLD,mpi_size,ierr)
+      call MPI_COMM_RANK(MPI_COMM_WORLD,mpi_rank,ierr)
+  
+      
+      allocate(jj_begin_para(0:mpi_size-1))
+      allocate(jj_end_para(0:mpi_size-1))
+      allocate(jj_nb_para(0:mpi_size-1))
+      
+      do i=0,mpi_size-1
+        jj_nb_para(i)=(jjm+1)/mpi_size
+        if ( i < MOD((jjm+1),mpi_size) ) jj_nb_para(i)=jj_nb_para(i)+1
+        
+        if (jj_nb_para(i) <= 2 ) then
+          
+         print *,"Arret : le nombre de bande de lattitude par process est trop faible (<2)."
+          print *," ---> diminuez le nombre de CPU ou augmentez la taille en lattitude"
+          
+          call MPI_ABORT(MPI_COMM_WORLD,-1, ierr)
+          
+        endif
+        
+      enddo
+      
+!      jj_nb_para(0)=11
+!      jj_nb_para(1)=25
+!      jj_nb_para(2)=25
+!      jj_nb_para(3)=12      
+
+      j=1
+      
+      do i=0,mpi_size-1 
+        
+        jj_begin_para(i)=j
+        jj_end_para(i)=j+jj_Nb_para(i)-1
+        j=j+jj_Nb_para(i)
+      
+      enddo
+      
+      jj_begin = jj_begin_para(mpi_rank)
+      jj_end   = jj_end_para(mpi_rank)
+      jj_nb    = jj_nb_para(mpi_rank)
+      
+      ij_begin=(jj_begin-1)*iip1+1
+      ij_end=jj_end*iip1
+      
+      if (mpi_rank.eq.0) then
+        pole_nord=.TRUE.
+      else 
+        pole_nord=.FALSE.
+      endif
+      
+      if (mpi_rank.eq.mpi_size-1) then
+        pole_sud=.TRUE.
+      else 
+        pole_sud=.FALSE.
+      endif
+        
+      print *,"jj_begin",jj_begin
+      print *,"jj_end",jj_end
+      print *,"ij_begin",ij_begin
+      print *,"ij_end",ij_end
+    
+#endif
+    
+    end subroutine init_parallel
+
+    
+    subroutine SetDistrib(jj_Nb_New)
+
+#ifdef CPP_PARALLEL
+
+    implicit none
+
+#include "dimensions90.h"
+#include "paramet90.h"
+
+      INTEGER,dimension(0:MPI_Size-1) :: jj_Nb_New
+      INTEGER :: i  
+  
+      jj_Nb_Para=jj_Nb_New
+      
+      jj_begin_para(0)=1
+      jj_end_para(0)=jj_Nb_Para(0)
+      
+      do i=1,mpi_size-1 
+        
+        jj_begin_para(i)=jj_end_para(i-1)+1
+        jj_end_para(i)=jj_begin_para(i)+jj_Nb_para(i)-1
+      
+      enddo
+      
+      jj_begin = jj_begin_para(mpi_rank)
+      jj_end   = jj_end_para(mpi_rank)
+      jj_nb    = jj_nb_para(mpi_rank)
+      
+      ij_begin=(jj_begin-1)*iip1+1
+      ij_end=jj_end*iip1
+
+#endif
+
+    end subroutine SetDistrib
+    
+    subroutine Finalize_parallel
+
+#ifdef CPP_PARALLEL
+
+    implicit none
+
+#include "dimensions90.h"
+#include "paramet90.h"
+      integer :: ierr
+      integer :: i
+      include 'mpif.h'
+      
+      deallocate(jj_begin_para)
+      deallocate(jj_end_para)
+      deallocate(jj_nb_para)
+      
+      call MPI_FINALIZE(ierr)
+ 
+#endif
+     
+    end subroutine Finalize_parallel
+    
+    subroutine Pack_Data(Field,ij,ll,row,Buffer)
+    implicit none
+
+#include "dimensions90.h"
+#include "paramet90.h"
+
+      integer, intent(in) :: ij,ll,row
+      real,dimension(ij,ll),intent(in) ::Field
+      real,dimension(ll*iip1*row), intent(out) :: Buffer 
+            
+      integer :: Pos
+      integer :: i,l
+      
+      Pos=0
+      do l=1,ll
+        do i=1,row*iip1
+          Pos=Pos+1
+          Buffer(Pos)=Field(i,l)
+        enddo
+      enddo
+      
+    end subroutine Pack_data 
+     
+    subroutine Unpack_Data(Field,ij,ll,row,Buffer)
+    implicit none
+
+#include "dimensions90.h"
+#include "paramet90.h"
+
+      integer, intent(in) :: ij,ll,row
+      real,dimension(ij,ll),intent(out) ::Field
+      real,dimension(ll*iip1*row), intent(in) :: Buffer 
+            
+      integer :: Pos
+      integer :: i,l
+      
+      Pos=0
+      
+      do l=1,ll
+        do i=1,row*iip1
+          Pos=Pos+1
+          Field(i,l)=Buffer(Pos)
+        enddo
+      enddo
+      
+    end subroutine UnPack_data
+      
+    subroutine exchange_hallo(Field,ij,ll,up,down)
+
+#ifdef CPP_PARALLEL
+
+    USE Vampir
+    implicit none
+#include "dimensions90.h"
+#include "paramet90.h"    
+    include 'mpif.h'
+    
+      INTEGER :: ij,ll
+      REAL, dimension(ij,ll) :: Field
+      INTEGER :: up,down
+      
+      INTEGER :: ierr
+      LOGICAL :: SendUp,SendDown
+      LOGICAL :: RecvUp,RecvDown
+      INTEGER, DIMENSION(4) :: Request
+      INTEGER, DIMENSION(MPI_STATUS_SIZE,4) :: Status
+      INTEGER :: NbRequest
+      REAL, dimension(:),allocatable :: Buffer_Send_up,Buffer_Send_down
+      REAL, dimension(:),allocatable :: Buffer_Recv_up,Buffer_Recv_down
+      INTEGER :: Buffer_size      
+      
+      call MPI_Barrier(MPI_COMM_WORLD,ierr)
+      call VTb(VThallo)
+      
+      SendUp=.TRUE.
+      SendDown=.TRUE.
+      RecvUp=.TRUE.
+      RecvDown=.TRUE.
+        
+      IF (pole_nord) THEN
+        SendUp=.FALSE.
+        RecvUp=.FALSE.
+      ENDIF
+  
+      IF (pole_sud) THEN
+        SendDown=.FALSE.
+        RecvDown=.FALSE.
+      ENDIF
+      
+      if (up.eq.0) then
+        SendDown=.FALSE.
+        RecvUp=.FALSE.
+      endif
+      
+      if (down.eq.0) then
+        SendUp=.FALSE.
+        RecvDown=.FALSE.
+      endif
+      
+      NbRequest=0
+  
+      IF (SendUp) THEN
+        NbRequest=NbRequest+1
+        buffer_size=down*iip1*ll
+        allocate(Buffer_Send_up(Buffer_size))
+        call PACK_Data(Field(ij_begin,1),ij,ll,down,Buffer_Send_up)
+        call MPI_ISSEND(Buffer_send_up,Buffer_Size,MPI_REAL8,MPI_Rank-1,1,     &
+                        MPI_COMM_WORLD,Request(NbRequest),ierr)
+      ENDIF
+  
+      IF (SendDown) THEN
+        NbRequest=NbRequest+1
+        
+        buffer_size=up*iip1*ll
+        allocate(Buffer_Send_down(Buffer_size))
+        call PACK_Data(Field(ij_end+1-up*iip1,1),ij,ll,up,Buffer_send_down)
+        
+        call MPI_ISSEND(Buffer_send_down,Buffer_Size,MPI_REAL8,MPI_Rank+1,1,     &
+                        MPI_COMM_WORLD,Request(NbRequest),ierr)
+      ENDIF
+    
+  
+      IF (RecvUp) THEN
+        NbRequest=NbRequest+1
+        buffer_size=up*iip1*ll
+        allocate(Buffer_recv_up(Buffer_size))
+              
+        call MPI_IRECV(Buffer_recv_up,Buffer_size,MPI_REAL8,MPI_Rank-1,1,  &
+                        MPI_COMM_WORLD,Request(NbRequest),ierr)
+     
+       
+      ENDIF
+  
+      IF (RecvDown) THEN
+        NbRequest=NbRequest+1
+        buffer_size=down*iip1*ll
+        allocate(Buffer_recv_down(Buffer_size))
+        
+        call MPI_IRECV(Buffer_recv_down,Buffer_size,MPI_REAL8,MPI_Rank+1,1,     &
+                        MPI_COMM_WORLD,Request(NbRequest),ierr)
+      
+        
+      ENDIF
+  
+      if (NbRequest > 0) call MPI_WAITALL(NbRequest,Request,Status,ierr)
+      IF (RecvUp)  call Unpack_Data(Field(ij_begin-up*iip1,1),ij,ll,up,Buffer_Recv_up)
+      IF (RecvDown) call Unpack_Data(Field(ij_end+1,1),ij,ll,down,Buffer_Recv_down)  
+
+      call VTe(VThallo)
+      call MPI_Barrier(MPI_COMM_WORLD,ierr)
+      RETURN
+
+#endif
+      
+    end subroutine exchange_Hallo
+    
+    
+    subroutine Gather_Field(Field,ij,ll,rank)
+
+
+
+    implicit none
+#include "dimensions90.h"
+#include "paramet90.h"    
+
+#ifdef CPP_PARALLEL
+    include 'mpif.h'
+#endif
+    
+      INTEGER :: ij,ll,rank
+      REAL, dimension(ij,ll) :: Field
+#ifdef CPP_PARALLEL
+      REAL, dimension(:),allocatable :: Buffer_send   
+      REAL, dimension(:),allocatable :: Buffer_Recv
+      INTEGER, dimension(0:MPI_Size-1) :: Recv_count, displ
+      INTEGER :: ierr
+      INTEGER ::i
+      
+      if (ij==ip1jmp1) then 
+         allocate(Buffer_send(iip1*ll*(jj_end-jj_begin+1)))
+         call Pack_Data(Field(ij_begin,1),ij,ll,jj_end-jj_begin+1,Buffer_send)
+      else if (ij==ip1jm) then
+         allocate(Buffer_send(iip1*ll*(min(jj_end,jjm)-jj_begin+1)))
+         call Pack_Data(Field(ij_begin,1),ij,ll,min(jj_end,jjm)-jj_begin+1,Buffer_send)
+      else
+         print *,ij
+	 stop 'erreur dans Gather_Field'
+      endif
+      
+      if (MPI_Rank==rank) then
+        allocate(Buffer_Recv(ij*ll))
+        do i=0,MPI_Size-1
+          
+          if (ij==ip1jmp1) then 
+            Recv_count(i)=(jj_end_para(i)-jj_begin_para(i)+1)*ll*iip1
+          else if (ij==ip1jm) then
+            Recv_count(i)=(min(jj_end_para(i),jjm)-jj_begin_para(i)+1)*ll*iip1
+          else
+            stop 'erreur dans Gather_Field'
+          endif
+          
+          if (i==0) then 
+            displ(i)=0 
+          else
+            displ(i)=displ(i-1)+Recv_count(i-1)
+          endif
+          
+        enddo
+        
+      endif
+      
+      call MPI_GATHERV(Buffer_send,(min(ij_end,ij)-ij_begin+1)*ll,MPI_REAL8,   &
+                        Buffer_Recv,Recv_count,displ,MPI_REAL8,rank,MPI_COMM_WORLD,ierr)
+      
+      if (MPI_Rank==rank) then                  
+      
+        if (ij==ip1jmp1) then 
+          do i=0,MPI_Size-1
+            call Unpack_Data(Field((jj_begin_para(i)-1)*iip1+1,1),ij,ll,                 &
+                             jj_end_para(i)-jj_begin_para(i)+1,Buffer_Recv(displ(i)+1))
+          enddo
+        else if (ij==ip1jm) then
+          do i=0,MPI_Size-1
+             call Unpack_Data(Field((jj_begin_para(i)-1)*iip1+1,1),ij,ll,                       &
+                             min(jj_end_para(i),jjm)-jj_begin_para(i)+1,Buffer_Recv(displ(i)+1))
+          enddo
+        endif
+      
+      endif
+
+#endif
+      
+    end subroutine Gather_Field
+    
+    subroutine AllGather_Field(Field,ij,ll)
+
+#ifdef CPP_PARALLEL
+
+    implicit none
+#include "dimensions90.h"
+#include "paramet90.h"    
+    include 'mpif.h'
+    
+      INTEGER :: ij,ll
+      REAL, dimension(ij,ll) :: Field
+      INTEGER :: ierr
+      
+      call Gather_Field(Field,ij,ll,0)
+      call MPI_BCAST(Field,ij*ll,MPI_REAL8,0,MPI_COMM_WORLD)
+
+#endif
+      
+    end subroutine AllGather_Field
+    
+   subroutine Broadcast_Field(Field,ij,ll,rank)
+
+#ifdef CPP_PARALLEL
+
+    implicit none
+#include "dimensions90.h"
+#include "paramet90.h"    
+    include 'mpif.h'
+    
+      INTEGER :: ij,ll
+      REAL, dimension(ij,ll) :: Field
+      INTEGER :: rank
+      INTEGER :: ierr
+      
+      call MPI_BCAST(Field,ij*ll,MPI_REAL8,rank,MPI_COMM_WORLD)
+
+#endif
+      
+    end subroutine Broadcast_Field
+        
+   
+    /*  
+  Subroutine verif_hallo(Field,ij,ll,up,down)
+
+#ifdef CPP_PARALLEL
+
+    implicit none
+#include "dimensions90.h"
+#include "paramet90.h"    
+    include 'mpif.h'
+    
+      INTEGER :: ij,ll
+      REAL, dimension(ij,ll) :: Field
+      INTEGER :: up,down 
+      
+      REAL,dimension(ij,ll): NewField
+      
+      NewField=0
+      
+      ijb=ij_begin
+      ije=ij_end
+      if (pole_nord) 
+      NewField(ij_be       
+
+#endif
+
+*/
+  end module parallel
Index: LMDZ4/branches/pre_V3/libf/dyn3d/ppm3d.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/ppm3d.F	(revision 525)
+++ LMDZ4/branches/pre_V3/libf/dyn3d/ppm3d.F	(revision 701)
@@ -737,5 +737,5 @@
 c     j=1 c'est le pôle Sud, j=JNP c'est le pôle Nord
       Q(I,  2,k,IC) = Q(I,  1,k,IC)
-      Q(I,JMR,k,IC) = Q(I,JMP,k,IC)
+      Q(I,JMR,k,IC) = Q(I,JNP,k,IC)
 400   CONTINUE
       endif
Index: LMDZ4/branches/pre_V3/libf/dyn3d/read_reanalyse.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/read_reanalyse.F	(revision 525)
+++ LMDZ4/branches/pre_V3/libf/dyn3d/read_reanalyse.F	(revision 701)
@@ -43,4 +43,5 @@
       integer varidpl,ncidQ,varidQ
       save ncidu,varidu,ncidv,varidv,ncidt,varidt,ncidps,varidps
+      save ncidpl
       save varidpl,ncidQ,varidQ
 
@@ -48,5 +49,5 @@
       real*4 tnc(iip1,jjp1,nlevnc),psnc(iip1,jjp1)
       real*4 Qnc(iip1,jjp1,nlevnc)
-      real*4 pl(nlevnc),presnc(iip1,jjp1,nlevnc)
+      real*4 pl(nlevnc)
 
       integer start(4),count(4),status
@@ -80,5 +81,5 @@
             varidv=NCVID(ncidv,'VWND',rcode)
             print*,'ncidv,varidv',ncidv,varidv
-            if (ncidpl.eq.-99) ncidpl=ncidu
+            if (ncidpl.eq.-99) ncidpl=ncidv
             endif
 
@@ -88,5 +89,5 @@
             varidt=NCVID(ncidt,'AIR',rcode)
             print*,'ncidt,varidt',ncidt,varidt
-            if (ncidpl.eq.-99) ncidpl=ncidu
+            if (ncidpl.eq.-99) ncidpl=ncidt
             endif
 
@@ -96,5 +97,5 @@
             varidQ=NCVID(ncidQ,'RH',rcode)
             print*,'ncidQ,varidQ',ncidQ,varidQ
-            if (ncidpl.eq.-99) ncidpl=ncidu
+            if (ncidpl.eq.-99) ncidpl=ncidQ
             endif
 
@@ -106,5 +107,5 @@
             endif
 
-c Coordonnee vertcale
+c Coordonnee verticale
             if (ncep) then
                print*,'Vous etes entrain de lire des donnees NCEP'
@@ -115,16 +116,8 @@
             endif
             print*,'ncidu,varidpl',ncidu,varidpl
-
-      endif
-
+      endif
       print*,'ok1'
 
-c -----------------------------------------------------------------
-c   lecture des champs u, v, T, ps
-c -----------------------------------------------------------------
-
-c  niveaux de pression
-c  -------------------
-
+c Niveaux de pression
       print*,'WARNING!!! Il n y a pas de test de coherence'
       print*,'sur le nombre de niveaux verticaux dans le fichier nc'
@@ -136,14 +129,13 @@
 c  passage en pascal
       pl(:)=100.*pl(:)
-c  passage des presions sur une grille 3D
-      do l=1,nlevnc
-         presnc(:,:,l)=pl(l)
-      enddo
-      if(first) then
-         do l=1,nlevnc
-            print*,'PL(',l,')=',pl(l)
-         enddo
-      endif
-
+      if (first) then
+       do l=1,nlevnc
+          print*,'PL(',l,')=',pl(l)
+       enddo
+      endif
+
+c -----------------------------------------------------------------
+c   lecture des champs u, v, T, ps
+c -----------------------------------------------------------------
 
 c  dimensions pour les champs scalaires et le vent zonal
@@ -159,4 +151,11 @@
       count(3)=nlevnc
       count(4)=1
+
+c mise a zero des tableaux 
+c ------------------------
+       unc(:,:,:)=0.
+       vnc(:,:,:)=0.
+       tnc(:,:,:)=0.
+       Qnc(:,:,:)=0.
 
 c  Vent zonal
